﻿/// info page for color names and dislay of these colors:
/// https://developer.mozilla.org/en-US/docs/Web/CSS/color_value


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2018V2
{

    public class ColorChanger : ContentPage
    {
        Page1 MeinMain;
        Image butback;
        Label lab;
        BoxView box;
        Button btnRGB, btnHSL;
        Slider sl,sl2,sl3,sl4,sl5,sl6;
        public ColorChanger(Page1 m)
        {
            
            MeinMain = m;
            butback = new Image
            {
                WidthRequest = 30,
                HorizontalOptions = LayoutOptions.Start,
                BackgroundColor = MeinMain.ColorBack,
                Source = ImageSource.FromResource(MeinMain.BackIcon)
            };

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            butback.GestureRecognizers.Add(tap);

            Label LabTitle = new Label
            {
                Text = "Demo Page for Color Changing",
                FontSize = 20.0,
                HorizontalOptions = LayoutOptions.End,
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText
            };
            StackLayout top = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children =
                {
                   butback,LabTitle
                },
                HorizontalOptions = LayoutOptions.FillAndExpand,
                BackgroundColor = MeinMain.ColorBack,
                Padding = new Thickness(10, 0, 0, 0)
            };

            lab = new Label
            {
                Text = "Top R--G--B, Bottom: Hue, Saturation, Luminosity",
                VerticalOptions = LayoutOptions.Start
            };
            btnRGB = new Button
            {
                Text = "Change RGB- Values",
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText

            };
            btnRGB.Clicked += BtnRGB_Clicked;

            btnHSL = new Button
            {
                Text="Change HSL - Values",
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText

            };
            btnHSL.Clicked += BtnHSL_Clicked;

             sl = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,

            };
            sl.ValueChanged += Sl_ValueChanged1;
            sl2 = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            sl2.ValueChanged += Sl2_ValueChanged;

            sl3 = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            sl3.ValueChanged += Sl3_ValueChanged;


            sl4 = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };
            sl4.ValueChanged += Sl4_ValueChanged;

            sl5 = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };
            sl5.ValueChanged += Sl5_ValueChanged;

            sl6 = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };

            sl6.ValueChanged += Sl6_ValueChanged;

            box = new BoxView
            {
                VerticalOptions = LayoutOptions.FillAndExpand,
                //Aspect = Aspect.AspectFit,
                HorizontalOptions = LayoutOptions.Fill,
                BackgroundColor = Color.Gray,
            };

 

            Content = new StackLayout
            {

                Children =
                {
                    top,lab,btnRGB,sl,sl2,sl3,
                    box,btnHSL,sl4,sl5,sl6
                }
            };
            if (Device.RuntimePlatform == Device.UWP)
                this.butback.IsVisible = false;
            else if (Device.RuntimePlatform == Device.iOS)
                this.butback.Source = ImageSource.FromResource(MeinMain.BackIconiOS);
        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            MeinMain.IsPresented = true;
        }

        private void BtnHSL_Clicked(object sender, EventArgs e)
        {
            rgbchange = false;
        }

        private void BtnRGB_Clicked(object sender, EventArgs e)
        {
            rgbchange = true;
        }

        bool rgbchange = true;

        private void Sl6_ValueChanged(object sender, ValueChangedEventArgs e)
        {//Saturation
            if (!rgbchange)
            {
                box.BackgroundColor = Color.FromHsla(sl4.Value / 255.0, sl5.Value / 255.0, sl6.Value / 255.0);
                sl.Value = box.BackgroundColor.R * 255;
                sl2.Value = box.BackgroundColor.G * 255;
                sl3.Value = box.BackgroundColor.B * 255;
                //sl4.Value = box.BackgroundColor.Hue * 255;
                //sl5.Value = box.BackgroundColor.Luminosity * 255;
                // sl6.Value = box.BackgroundColor.Saturation * 255;
            }
        }

        private void Sl5_ValueChanged(object sender, ValueChangedEventArgs e)
        { // Luminosity
            if (!rgbchange)
            {
                box.BackgroundColor = Color.FromHsla(sl4.Value / 255.0, sl5.Value / 255.0, sl6.Value / 255.0);
                sl.Value = box.BackgroundColor.R * 255;
                sl2.Value = box.BackgroundColor.G * 255;
                sl3.Value = box.BackgroundColor.B * 255;
                //sl4.Value = box.BackgroundColor.Hue * 255;
                //sl5.Value = box.BackgroundColor.Luminosity * 255;
                //sl6.Value = box.BackgroundColor.Saturation * 255;
            }
        }

        private void Sl4_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            // hue
            if (!rgbchange)
            {
                box.BackgroundColor = Color.FromHsla(sl4.Value / 255.0, sl5.Value / 255.0, sl6.Value / 255.0);
                sl.Value = box.BackgroundColor.R * 255;
                sl2.Value = box.BackgroundColor.G * 255;
                sl3.Value = box.BackgroundColor.B * 255;
                //sl4.Value = box.BackgroundColor.Hue * 255;
                //sl5.Value = box.BackgroundColor.Luminosity * 255;
                //sl6.Value = box.BackgroundColor.Saturation * 255;
            }
        }

        private void Sl3_ValueChanged(object sender, ValueChangedEventArgs e)
        { //R
            if (rgbchange)
            {
                box.BackgroundColor = Color.FromRgb(sl.Value / 255.0, sl2.Value / 255.0, sl3.Value / 255.0);
                //sl.Value = box.BackgroundColor.R*255;
                //sl2.Value = box.BackgroundColor.G * 255;
                //sl3.Value = box.BackgroundColor.B * 255;
                sl4.Value = box.BackgroundColor.Hue * 255;
                sl6.Value = box.BackgroundColor.Luminosity * 255;
                sl5.Value = box.BackgroundColor.Saturation * 255;
            }
        }

        private void Sl_ValueChanged1(object sender, ValueChangedEventArgs e)
        { // G
            if (rgbchange)
            {
                box.BackgroundColor = Color.FromRgb(sl.Value / 255.0, sl2.Value / 255.0, sl3.Value / 255.0);
                //sl.Value = box.BackgroundColor.R * 255;
                //sl2.Value = box.BackgroundColor.G * 255;
                //sl3.Value = box.BackgroundColor.B * 255;
                sl4.Value = box.BackgroundColor.Hue * 255;
                sl6.Value = box.BackgroundColor.Luminosity * 255;
                sl5.Value = box.BackgroundColor.Saturation * 255;
            }
        }


        private void Sl2_ValueChanged(object sender, ValueChangedEventArgs e)
        { //
            if (rgbchange)
            {
                box.BackgroundColor = Color.FromRgb(sl.Value / 255.0, sl2.Value / 255.0, sl3.Value / 255.0);
                //sl.Value = box.BackgroundColor.R * 255;
                //sl2.Value = box.BackgroundColor.G * 255;
                //sl3.Value = box.BackgroundColor.B * 255;
                sl4.Value = box.BackgroundColor.Hue * 255;
                sl6.Value = box.BackgroundColor.Luminosity * 255;
                sl5.Value = box.BackgroundColor.Saturation * 255;
            }
        }

    }
}