﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2018V2
{
    public class PageStartInfo : ContentPage
    {
        Page1 MeinMain;
        Label lab;
        Image butback;
        Switch sw;
        public PageStartInfo(Page1 m)
        {
            MeinMain = m;

            butback = new Image
            {
                WidthRequest = 30,
                HorizontalOptions = LayoutOptions.Start,
                BackgroundColor = MeinMain.ColorBack,
                Source = ImageSource.FromResource(MeinMain.BackIcon)
            };

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            butback.GestureRecognizers.Add(tap);

            Label LabTitle = new Label
            {
                Text = "Start Info Page",
                FontSize = 20.0,
                HorizontalOptions = LayoutOptions.End,
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText
            };
            StackLayout top = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children =
                {
                   butback,LabTitle
                },
                HorizontalOptions = LayoutOptions.FillAndExpand,
                BackgroundColor = MeinMain.ColorBack,
                Padding = new Thickness(10, 0, 0, 0)
            };


             sw = new Switch
            {
                
            };
            sw.Toggled += Sw_Toggled;

            lab = new Label
            {
                Text = "Info"
            };
            Label lab1 = new Label
            {
                Text = "English"
            };

            Label lab2 = new Label
            {
                Text = "Deutsch"
            };

            StackLayout slo = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children = { lab1, sw, lab2 }
            };

            Content = new StackLayout
            {
                Children = { top,slo,
                new ScrollView {Content= lab}
                }
               
            };
            if (Device.RuntimePlatform == Device.UWP)
                this.butback.IsVisible = false;
            else if (Device.RuntimePlatform == Device.iOS)
                this.butback.Source = ImageSource.FromResource(MeinMain.BackIconiOS);
            Sw_Toggled(null, null);
        }

        private void Sw_Toggled(object sender, ToggledEventArgs e)
        {
            if (!sw.IsToggled)
                lab.Text = "This App should demonstrate some properties of the cross platform tool Xamarin.Forms of Visual studio. " +
                    "This App is completely developped in C# using MS- Tool Visual Studio with the Xamarin plugin at Technische Hochschule Lübeck in Germany. " +
                    "It is a Master-Detail Pagecontrol together with an addition of a Headline, which contains a Back- Button in iOS and Android to help the " +
                    "user to go back to the master page. The other pages demostrate some typical properties of the User Interface (UI) like Layout Options, Rotation " +
                    "Gesture control, color changing and as addition contains a simple tool used in control systems to identify simple 2PT1- processes. See the Reuter- Page. " +
                    "In total the author offers the complete source code to anybody who wants to start App development using this tool. You can download the source on the " +
                    "author homepage www.joergbayerlein.de in the csharp- section."
                    ;
            else
                lab.Text = "Diese App soll einige Eigenschaften demonstrieren, die mit dem dem Cross-Platform-Tool Xamarin.Forms in Visual Studio entwickelt werden können. " +
                    "Sie ist vollständig in C# programmiert und benutzt Visual Studio von Microsoft zusammen mit dem Xamarin- plugin und ist an der Technischen Hochschule Lübeck im " +
                    "Rahmen einer Vorlesung zu diesem Thema vom Autor entwickelt worden. Es ist eine Master- Detail- Seitenkontrolle, in der eine Kopfzeile ergänzt wurde, die einen Zurück- button " +
                    "enthält, um den iOS und Android- Usern das Öffnen der Masterseite zu erleichtern. Die anderen Seiten demonstrieren typische User- Interface- (UI)- Methoden wie " +
                    "LayoutOptions, Rotation, Gesture Control, Farbeinstellung und als Addon ein kleines Tool zum einfachen Identifizieren von 2PT1- Strecken in der Regelungstechnik. " +
                    "Siehe dazu die Reuter- Seite. Als Zusatzangebot bietet der Auto den vollständigen Sourcecode für Interessierte an, die in die App- Entwicklung mit diesem Tool einsteigen wollen. " +
                    "Dazu kann man den Source auf seiner Homepage www.joergbayerlein.de im C#- Abschnitt finden. "
;        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            MeinMain.IsPresented = true;
        }

       
    }
}